<?php
//   File Check and other Utility Functions
//
// Jun Kuwamura <juk@yokohama.email.ne.jp>
//	Sun Sep 15 23:02:49 JST 2002
//
// 2002-09-15 JuK Seperated from imagetool.php
//

///////////////////////////////////////
// Debug write function
///////////////////////////////////////
function Debug( $strings, $level, $line=0 ) {
  global $TEST;
  if ($level < $TEST) {
    echo "<br><font color=green>debug";
    if ($line) {
      echo "($line)";
    }
    echo ": $strings</font><br>\n";
  }
}

///////////////////////////////////////
// Error output function
///////////////////////////////////////
function Error( $strings, $line=0 ) {
  echo "<br><font color=red>";
  echo "Error";
  if ($line) {
    echo "($line)";
  }
  echo ": $strings</font><br>\n";
}

///////////////////////////////////////////////////////////////////////
// Check a directory (and a file) be readable or not.
//	$dir_name: directory path name
//	$f_name: file name to be checked in the directory($dir_name)
///////////////////////////////////////////////////////////////////////
function ChkReadable( $dir_name, $f_name = ".", $line=__LINE__)
{
  global $TEST;
  if ( $TEST > 3 ) {
    echo "Line: $line";
    include( "print_func_args.php" );
  }

  // Check the directory existence and is readable.
  if (! is_dir($dir_name) ) {
    Error("No directory found: $dir_name", $line);
    Debug("<pre>	Create a directory $dir_name with permission to web server.</pre>", 1);
    Debug("<a href=\"".$_SERVER['PHP_SELF']."\">Return</a>", 1);
    return;
  }
  if (! is_readable("$dir_name") ) {
    Error("Directory is not readable: $dir_name", $line);
    Debug("<pre>	Give file read permission to webserver user.</pre>", 1);
    Debug("<a href=\"".$_SERVER['PHP_SELF']."\">Return</a>", 1);
    return;
  }

  // Check the file existence and is readable if specified
  if ( $f_name !=  "." ) {
    if ( ! file_exists("$dir_name/$f_name") ) {
      Debug("Error($line):  File is not existed: $dir_name/$f_name", 9);
      Debug("<a href=\"".$_SERVER['PHP_SELF']."\">Return</a>", 9);
      return;
    } else {
      if (! is_readable("$dir_name/$f_name") ) {
	Error("File is not readable: $dir_name/$f_name", $line);
	Debug("<pre>   Give file read permission to webserver user.</pre>", 1);
	Debug("<a href=\"".$_SERVER['PHP_SELF']."\">Return</a>", 1);
	return;
      }
    }
  }
  return "$dir_name/$f_name";
}

///////////////////////////////////////////////////////////////////////
// Check a directory (and a file) be writable or not.
//	$dir_name: directory path name
//	$f_name: file name to be checked in the directory($dir_name)
///////////////////////////////////////////////////////////////////////
function ChkWritable( $dir_name, $f_name = ".", $line=__LINE__)
{
  global $TEST;
  if ( $TEST > 3 ) {
    echo "Line: $line";
    include( "print_func_args.php" );
  }

  // Check the directory existence and is writable.
  if (! is_dir("$dir_name") ) {
    Error("No directory found:  $dir_name", $line);
    Debug("<pre>	Create a directory $dir_name with permission to web server.</pre>", 1);
    Debug("<a href=\"".$_SERVER['PHP_SELF']."\">Return</a>", 1);
    return;
  }
  if (! is_writeable("$dir_name") ) {
    Error("Directory is not writable:  $dir_name", $line);
    Debug("<pre>	Give file read/write permission to webserver user.</pre>", 1);
    Debug("<a href=\"".$_SERVER['PHP_SELF']."\">Return</a>", 1);
    return;
  }

  // Check the file no existence nor is writable if specified
  if ( $f_name !=  "." ) {
    if ( file_exists($f_name) == true ) {
      if (! is_writeable( "$dir_name/$f_name" ) ) {
	Error("File is not writable:  $dir_name/$f_name", $line);
	Debug("<pre>   Give file read/write permission to webserver user.</pre>", 1);
	Debug("<a href=\"".$_SERVER['PHP_SELF']."\">Return</a>", 1);
	return;
      }
    }
  }
  return "$dir_name/$f_name";
}

?>
