<?php
//   Directory File List Class
//	sort items in name, mtime or size order by specification.
//
// Jun Kuwamura <juk@yokohama.email.ne.jp>
//		Sun Sep 15 22:30:09 JST 2002
//
//
class DirFileList
{
  var $gdate;
  var $path;
  var $items;
  var $size;
  var $mtime;
  var $order;

  function DirFileList ($dir_path)
  {
    $this->order = "ASC";	// or "DESC"
    $this->gdate = date("Y-m-d");
    $this->path = $dir_path;
    $this->items = array();
    $d = dir("$dir_path");
    while($entry=$d->read()) {
      if ( is_file("$dir_path/$entry") ) {
	$this->items[] = "$entry";
	$this->size[$entry] = filesize("$dir_path/$entry");
	$this->mtime[$entry] = filemtime("$dir_path/$entry");
      }
    }
    $d->close();
  }

  function set_order ( $scend )
  {
    $sc = strtolower(substr(ltrim($scend), 0, 1));
    switch ($sc) {
    case 'd':
      $this->order = "DESC";
      break;
    case 'a':
    default:
      $this->order = "ASC";
      break;
    }
  }

  function set_order_by ($bym)
  {
    $by = strtolower(substr(ltrim($bym), 0, 2));
    switch ($by) {
    case 'mt':
      $this->order_by = "mtime";
      break;
    case 'si':
      $this->order_by = "size";
      break;
    case 'na':
    default:
      $this->order_by = "name";
      break;
    }
  }

  function sort_items ()
  {
    if ($this->order == "DESC") {
      $sortfunc = "arsort";
    } else {
      $sortfunc = "asort";
    }
    switch ($this->order_by) {
    case "mtime":
	$sortfunc($this->mtime, SORT_NUMERIC);
	reset($this->mtime);
	$this->items = array();
	while (list ($key, $val) = each ($this->mtime)) {
	  $this->items[] = $key;
	}
	reset($this->mtime);
	reset($this->items);
      break;
    case "size":
	$sortfunc($this->size, SORT_NUMERIC);
	reset($this->size);
	$this->items = array();
	while (list ($key, $val) = each ($this->size)) {
	  $this->items[] = $key;
	}
	reset($this->size);
	reset($this->items);
      break;
    case "name":
    default:
	$sortfunc($this->items, SORT_STRING);
	reset($this->items);
      break;
    }
  }

  function current_item ()
  {
    return current($this->items);
  }
  function key_item ()
  {
    return key($this->items);
  }
  function next_item ()
  {
    return next($this->items);
  }
  function previous_item ()
  {
    return previous($this->items);
  }
  function end_item ()
  {
    return end($this->items);
  }
  function reset_item ()
  {
    return reset($this->items);
  }

  function print_items ()
  {
    echo "items($this->gdate)<br>";
    // var_dump($this->items);
    while (list ($key, $val) = each ($this->items)) {
      echo "$key, $val<br>";
    }
  }

  function print_mtime ()
  {
    echo "mtime($this->gdate)<br>";
    //var_dump($this->items);
    while (list ($key, $val) = each ($this->mtime)) {
      echo "$key, $val<br>";
    }
  }

  function print_size ()
  {
    echo "size($this->gdate)<br>";
    //var_dump($this->items);
    while (list ($key, $val) = each ($this->size)) {
      echo "$key, $val<br>";
    }
  }
}
?>

<?php
// The followngs are the test statements.
$TEST=0;
if ($TEST) {
$original_directory=".";
echo "////////// directory: ".$original_directory." ////////////////////";
$file_list = new DirFileList ("$original_directory");
echo "<br>file size list:<br>";
$file_list->print_size();
echo "<br>sort by size:<br>";
$file_list->set_order_by("size");
$file_list->sort_items();
$file_list->print_items();
echo "<br>file mtime list:<br>";
$file_list->print_mtime();
echo "<br>sort by mtime in descendant order:<br>";
$file_list->set_order_by("mtime");
$file_list->set_order("descend");
$file_list->sort_items();
//var_dump($file_list->items);
$file_list->reset_item();
echo "<table>";
while ($val = $file_list->current_item()) {
  echo "<tr><td>$val</td>";
  echo "    <td align=right>{$file_list->size[$val]}</td>";
  echo "    <td>{$file_list->mtime[$val]}</td>  </tr>";
  $file_list->next_item();
}
echo "</table>";
echo "<br>sort by name:<br>";
$file_list->set_order_by("name");
$file_list->set_order("ascend");
$file_list->sort_items();
$file_list->print_items();
}
?>
