<?php
//
// Jun Kuwamura <juk@yokohama.email.ne.jp>
//               Tue Aug  8 13:36:12 JST 2000
//
// 2002-09-16 JuK Use file list instead of directory info. in while loop.
// 2002-09-15 JuK Add simple header and footer.
// 2002-08-28 JuK Add ReCreate image for zero sized file.
// 2002-08-28 JuK Add edit mode for remarks(readonly or none)
// 2002-07-04 JuK Add original image viewer.
// 2002-07-04 JuK Add edit mode for remarks(append or overwrite)
// 2002-03-15 JuK Mod independent browse size.
// 2002-02-17 JuK Mod devide functions into another files.
// 2002-02-15 JuK Mod modularized by small functions with debug print.
// 2002-02-14 JuK Add $original directory.
// 2002-02-13 JuK Mod for register_globals=Off, register_argc_argv=Off.
// 2001-12-09 JuK Add up/previous/next navigators for zoom page.
// 2001-08-22 JuK Add PHPSELF before all '?'
// 2001-06-03 JuK generate present(browse size) file in work directory.
// 2001-05-05 JuK eliminate directory from GetImageSize.
// Jan/21/2001 JuK adds table layout and comment editor.
//
//
$copyright="<A HREF=\"".$_SERVER['PHP_SELF']."\">".$_SERVER['PHP_SELF']."</A><HR>
	(c)2000-2002 imagelist.php by Jun Kuwamura &lt;juk at yokohama.email.ne.jp&gt;.";
$header="<html><header>\n<title>imagelist</title>\n</header><body>\n";
$footer="</body></html>\n";

// include parameters
require_once('imageparam.php');
// include functions
require_once('imagemode.php');
require_once('dirfilelist.php');

// client cache off
Header("Expires: Tue, 08 Aug 2000 05:00:00 UTC");
Header("Last-Modified: " . gmdate("D, d M Y H:i:s") . "GMT");
Header("Cache-Control: no-cache, must-revalidate");     // HTTP/1.1
Header("Pragma: no-cache");                             // HTTP/1.0

if ( $TEST > 1 ) {
  include( "print_var_dump.php" );
}

echo "$header";

//////////////////////////////////
//
// Main Program Start from here
//
//////////////////////////////////

// Check the directory in which original image is existed.
$filename = ChkReadable("$original_directory", ".", __LINE__);
if ( empty($filename) ) {
  Error("Original directory is not readable: $original_directory", __LINE__);
  exit;
}
if ($edit_rmk_mode == "a" || $edit_rmk_mode == "o") {
  // Check the directory in which thumbnail image is created.
  $filename = ChkWritable("$thumbnail_directory", ".", __LINE__);
  if ( empty($filename) ) {
    Error("ThumbNail directory is not found nor writable: $thumbnail_directory", __LINE__);
    exit;
  }
  // Check the directory in which browsable image is created.
  $filename = ChkWritable("$work_directory", ".", __LINE__);
  if ( empty($filename) ) {
    Error("Work directory is not writable: $work_directory", __LINE__);
    exit;
  }
} elseif ($edit_rmk_mode == "r") {
  $filename = ChkReadable("$thumbnail_directory", ".", __LINE__);
  if ( empty($filename) ) {
    Error("ThumbNail directory is not found nor readable: $thumbnail_directory", __LINE__);
    exit;
  }
}
  
$imlist = new DirFileList ("$original_directory");
//$imlist->set_order_by("mtime");
//$imlist->set_order_by("size");
$imlist->set_order_by("name");
$imlist->sort_items();
$items = $imlist->items;
//var_dump($items);

//
// Execute functions specified with mode
//
switch ( $_GET['mode'] ) {
case "create":
  CreatThumbNails( $original_directory,
		     $thumbnail_directory, $work_directory, $items,
		     $thumbnail_width, $thumbnail_height,
		     $work_width, $work_height,
		     $_GET['image'], $_SERVER['PHP_SELF'] );
  break;
case "list":
  ListImgDir( $original_directory, $items, $_SERVER['PHP_SELF'] );
  break;
case "edit":
  EditImgRemarks( $original_directory, $thumbnail_directory,
		  $_GET['image'], $_SERVER['PHP_SELF'],
		  $edit_rmk_mode );
  break;
case "save":
  SaveImgRemarks( $original_directory,
		  $thumbnail_directory, $work_directory,
		  $work_width, $work_height,
		  $_GET['image'], $_GET['remark'], $_SERVER['PHP_SELF'],
		  $edit_rmk_mode);
  //no break;
case "show":
  ShowImgUp( $original_directory, $thumbnail_directory, $work_directory, $items,
	     $_GET['image'], $_GET['remark'], $_SERVER['PHP_SELF'],
	     $edit_rmk_mode );
  break;
case "max":
  ShowImgMax( $original_directory, $thumbnail_directory, $work_directory,
	     $_GET['image'], $_GET['remark'], $_SERVER['PHP_SELF'] );
  break;
default:
  //
  // default for Image List
  //
  if  ( empty($_GET['simple']) ) {
    // Image List in Table Format,
    // without any mode above makes image list(initial page).
    //
    if( extension_loaded('gd') ){
      $fh=ImageFontHeight(1);
    } else {
      // when you donot have GD.
      $fh = 6; 
    }
    $nc = $browse_width/($thumbnail_width+$fh*2);
    $nc = (int)$nc;
    //$nr = $browse_height/($thumbnail_height+$fh*2);
    //$nr = (int)$nr;
    Debug ( $nc, 8 );

    // list image index in the current directory
    // (show icon if existed)
    $i=0;
    if ($edit_rmk_mode != "n") {
	echo "<TABLE BORDER=1>\n";
    } else { //  No-Border
	echo "<TABLE BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"0\">\n";
    }
    while (list ($key, $entry) = each ($items)) {
      if ( is_file("$original_directory/$entry") && GetImgPixels("$original_directory/$entry") ) {
	$i = $i + 1;
	$mi = $i % $nc ;
	if ( $mi == 1 ) {
	  echo "<TR><TD>";
	} else {
	  echo "<TD>";
	}

	if ($edit_rmk_mode != "n") {
	  if ( GetImgType("$thumbnail_directory/$entry") ) {
	    echo "<A href=\"".$_SERVER['PHP_SELF']."?mode=show&image=$entry\">$entry<br>\n";
	    echo "<img src=\"$thumbnail_directory/$entry\"></A><br>\n"; 
	  } else {
	    echo "<A href=\"".$_SERVER['PHP_SELF']."?mode=create&image=$entry\">$entry</A><br>\n";
	  }
	  $label = RdImgRemark($thumbnail_directory, $entry, __LINE__);
	  if ($edit_rmk_mode == "a" || $edit_rmk_mode == "o") {
	    if ( ! empty($label) ) {
	      $label = ereg_replace ( "--\t--\n", "", $label );
	      $label = ereg_replace ( "\t__ .* __\t\n", "", $label );
	      $label = substr($label, 0, $thumblabel_length) . "...";
	    } else {
	      $label = "edit";
	    }
	    echo "<a href=\"".$_SERVER['PHP_SELF']."?mode=edit&image=$entry\">$label</a><br>\n";
	  } else {
	    echo "$label<br>\n";
	  }
	} else { // No-Border, Non-Label
	  if ( GetImgType("$thumbnail_directory/$entry") ) {
	    echo "<A href=\"".$_SERVER['PHP_SELF']."?mode=show&image=$entry\">\n";
	    echo "<img src=\"$thumbnail_directory/$entry\" BORDER=\"0\"></A><br>\n"; 
	  } else {
	    echo "<A href=\"".$_SERVER['PHP_SELF']."?mode=create&image=$entry\">$entry</A><br>\n";
	  }
	}

	if ( $mi == 0 ) {
	echo "</TD></TR>\n";
	} else {
	  echo "</TD>\n";
	}
      }
    }
    echo "</TABLE>\n";
  } else {
    // Image List in Simple Format
    // (show icon if existed)
    while (list ($key, $entry) = each ($items)) {
      if ( GetImgType("$original_directory/$entry") ) {
	if ( GetImgType("$thumbnail_directory/$entry") ) {
	  echo "<A href=\"$original_directory/$entry\"><br>\n"; 
	  echo "$entry<br>\n";
	  echo "<img src=\"$thumbnail_directory/$entry\"><br>\n"; 
	  echo "</A><br>\n"; 
	} else {
	  echo "<a href=\"".$_SERVER['PHP_SELF']."?mode=show&image=$entry\">$entry</a><br>\n";
	}
      }
    }
  }
  break;
}

// End of Program.
echo "$copyright";
echo "$footer";
?>
